/*
 * MayorAUnaEdadDependiente.java
 *
 * Created on 24 de marzo de 2007, 03:21 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

/**
 * 
 * @author Julian
 */
public class MayorAUnaEdadDependiente extends AbstractRule {

	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	/** Creates a new instance of CampoLlenoParaUnValorDiferenteDeOtroCampo */

	public MayorAUnaEdadDependiente() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {

		if (registro[new Integer((String) getParams()[0]).intValue()]
				.equals(getParams()[1])) {
			String fechaNacimiento = registro[new Integer(
					(String) getParams()[2]).intValue()];

			if (!ValidarFecha.esFecha(fechaNacimiento))
				return false;

			Date dtFechaNacimiento;

			try {
				dtFechaNacimiento = sdf.parse(fechaNacimiento);
			} catch (Exception e) {
				return false;
			}

			long edadDias = ObtenerDiasEntreFechas.calcular(dtFechaNacimiento,
					Calendar.getInstance().getTime());
			;
			long annos = edadDias / 365;

			if (annos > new Integer((String) getParams()[3]).longValue()
					&& !field.equals(getParams()[4])) {

				return true;

			}

		}
		return false;
	}

}